<?php

/**
 * 
 * outputs all related to table with paging
 *
 */
class UniteTableUC{
	
	private $isPaging = false;
	private $page;
	private $inPage;
	private $total;
	private $numPages;
	private $baseUrl;
	
	private $defaultInPage = 10;
		
	
	/**
	 * validate that the paging is inited
	 */
	private function validatePaging(){
		
		if($this->isPaging == false)
			UniteFunctionsUC::throwError("The paging should be available");
		
	}
	
	
	/**
	 * function for search content and sorting
	 */
	public function getSearchFunction($url){
		
		$html = '<div class="unite-float-left">';
		
		$html .= '<form method="get" action="'.$url.'"><input id="search_form" name="search" type="text" class="unite-input-medium no-margin-bottom unite-cursor-text" value="'.JFactory::getApplication()->input->get('search').'"/> <button class="unite-button-primary" type="submit" name="start_search" value="1">Search layout</button>
		<input type="hidden" name="option" value="'.JFactory::getApplication()->input->get('option').'">';
		
		if(JFactory::getApplication()->input->get('view')){
		$html .= '<input type="hidden" name="view" value="'.JFactory::getApplication()->input->get('view').'">';
		}
		
		if(JFactory::getApplication()->input->get('search') && JFactory::getApplication()->input->get('start_search')){
		$html .= '<a href="?option='.JFactory::getApplication()->input->get('option').'" class="unite-button-secondary">Clear input</a>';
		}
		
		if(JFactory::getApplication()->input->get('sort')){
		$html .= '<input type="hidden" name="sort" value="'.JFactory::getApplication()->input->get('sort').'">';
		}
		
		if(JFactory::getApplication()->input->get('number')){
		$html .= '<input type="hidden" name="number" value="'.JFactory::getApplication()->input->get('number').'">';
		}
		
		
		
		$html .='</form></div>';
		
		echo $html;
		
	}
	
	/**
	 * get paging options from get and default
	 */
	public function getPagingOptions(){
		
		$page = UniteFunctionsUC::getGetVar("table_page",1,UniteFunctionsUC::SANITIZE_ID);
		$page = (int)$page;
		
		$inpage = UniteFunctionsUC::getGetVar("table_inpage", $this->defaultInPage,UniteFunctionsUC::SANITIZE_ID);
		$inpage = (int)$inpage;
		
		$output = array();
		$output["page"] = $page;
		if(JFactory::getApplication()->input->get('number')){
		$output["inpage"] = JFactory::getApplication()->input->get('number');
		}else{
		$output["inpage"] = $inpage;
		}
		
		return($output);
	}
	
	
	/**
	 * set paging data
	 */
	public function setPagingData($baseURl, $data){
		
		$this->baseUrl = $baseURl;
		
		$this->total = UniteFunctionsUC::getVal($data, "total");
		$this->page = UniteFunctionsUC::getVal($data, "page");
		$this->inPage = UniteFunctionsUC::getVal($data, "inpage");
		$this->numPages = UniteFunctionsUC::getVal($data, "num_pages");
		
		UniteFunctionsUC::validateNotEmpty($this->inPage, "in page");
		if($this->total > 0){
			UniteFunctionsUC::validateNotEmpty($this->page, "page");
			UniteFunctionsUC::validateNotEmpty($this->numPages, "num pages");
		}
		
		$this->isPaging = true;
	}
	
	/**
	 * get page url
	 */
	private function getUrlPage($page){
		
		if(JFactory::getApplication()->input->get('search') && JFactory::getApplication()->input->get('start_search')){
		$search = "&search=".JFactory::getApplication()->input->get('search')."&start_search=".JFactory::getApplication()->input->get('start_search');
		}
		
		$urlPage = UniteFunctionsUC::addUrlParams($this->baseUrl, "table_page=".$page.$search);
		
		return($urlPage);
	}
	
	/**
	 * get number of query request 
	 */
	public function getNumSearch($query){
	  $db = JFactory::getDbo();
				
	  $db->setQuery($query);
		
	  $db->execute();
                
      $num_rows = $db->getNumRows();

      $result = $db->loadRowList();
                
      return $num_rows;
	}
	
	/**
	 * get number of count pages 
	 */
	public function numPage($number){
		
		if(JFactory::getApplication()->input->get('number')){
		$numPage = $number / JFactory::getApplication()->input->get('number');
		}else{
		$numPage = $number / 10;
		}
		
		
		if(is_int($numPage)){
		$pageNum = $numPage;
		}else{
		$pageNum = $numPage + 1;
		}
		
		return (int)$pageNum;
		
	}
	
	/**
	 * get input with count content, about 10,25,50,100
	 */
	public function getNumberInput(){
		
		$select_ten = '';
		$select_twenty_five = '';
		$select_fifth = '';
		$select_houndred = '';
		
		if(JFactory::getApplication()->input->get('number') == 10){
			$select_ten = 'selected';
		}
		
		if(JFactory::getApplication()->input->get('number') == 25){
			$select_twenty_five = 'selected';
		}
		
		if(JFactory::getApplication()->input->get('number') == 50){
			$select_fifth = 'selected';
		}
		
		if(JFactory::getApplication()->input->get('number') == 100){
			$select_houndred = 'selected';
		}
		
		$html = '<div class="unite-float-right class-for-number">';
		$html .= '<form method="get">';
		$html .= '<select name="number" onchange="this.form.submit()">';
		$html .= '<option value="10" '.$select_ten.'>10</option>';
		$html .= '<option value="25" '.$select_twenty_five.'>25</option>';
		$html .= '<option value="50" '.$select_fifth.'>50</option>';
		$html .= '<option value="100" '.$select_houndred.'>100</option>';
		$html .= '</select>';
		if(JFactory::getApplication()->input->get('option')){
		$html .= '<input type="hidden" name="option" value="'.JFactory::getApplication()->input->get('option').'">';
		}
		
		if(JFactory::getApplication()->input->get('sort')){
		$html .= '<input type="hidden" name="sort" value="'.JFactory::getApplication()->input->get('sort').'">';
		}
		
		if(JFactory::getApplication()->input->get('search')){
		$html .= '<input type="hidden" name="search" value="'.JFactory::getApplication()->input->get('search').'">';
		}
		
		if(JFactory::getApplication()->input->get('start_search')){
		$html .= '<input type="hidden" name="start_search" value="'.JFactory::getApplication()->input->get('start_search').'">';
		}
		
		if(JFactory::getApplication()->input->get('view')){
		$html .= '<input type="hidden" name="view" value="'.JFactory::getApplication()->input->get('view').'">';
		}
		$html .= '</form>';
		$html .= '</div>';
		
		return $html;
	}
	
	/**
	 * get pagination html
	 */
	public function getPaginationHtml(){
		
		$this->validatePaging();
		
		$item_per_page = $this->inPage;
		$current_page = $this->page;
		$total_records = $this->total;
		$total_pages = $this->numPages;
		$page_url = $this->baseUrl;
		
		$search = '';
		
		if(JFactory::getApplication()->input->get('search') && JFactory::getApplication()->input->get('start_search')){
		
		$numSearch = $this->getNumSearch("SELECT id FROM ".GlobalsUC::$table_layouts." WHERE title LIKE '%".JFactory::getApplication()->input->get('search')."%'");
		
		if($numSearch <= 10){
			return false;
		}
		
		$total_records = $numSearch;
		
		$total_pages = self::numPage($numSearch);
		
		$search .= '&search='.JFactory::getApplication()->input->get('search').'&start_search='.JFactory::getApplication()->input->get('start_search');
		
		}
		
		if(JFactory::getApplication()->input->get('sort')){
			
		$search .= '&sort='.JFactory::getApplication()->input->get('sort');
			
		}
		
		
		if(JFactory::getApplication()->input->get('number')){
			
		$search .= '&number='.JFactory::getApplication()->input->get('number');
			
		}
		
		//num pages to show links
		$pagesForShowLinks = 5;
		//$isShowExtras = ($total_pages > $pagesForShowLinks);
		
		$isShowExtras = true;
		
		$pagination = '';
		if($total_pages > 0 && $total_pages != 1 && $current_page <= $total_pages){ //verify total pages and current page number
			$pagination .= '<ul class="unite-pagination class-for-pagination">';
			
			$right_links    = $current_page + 8;
			$previous       = $current_page - 1; //previous link
			$next           = $current_page + 1; //next link
			$first_link     = true; //boolean var to decide our first link
			
			//put first and previous
			if($current_page > 1 && $isShowExtras == true){
				$previous_link = ($previous==0)?1:$previous;
				
				$urlFirst = $this->getUrlPage(1);
				$urlPrev = $this->getUrlPage($previous_link);
				
				$titleFirst = __("First", ADDONLIBRARY_TEXTDOMAIN);
				$titlePrev = __("Previous", ADDONLIBRARY_TEXTDOMAIN);
				
				$textFirst = "";
				$textPrev = "";
				
				$pagination .= '<li class="unite-first"><a href="'.$urlFirst.$search.'" title="'.$titleFirst.'" > &laquo; '.$textFirst.'</a></li>'; //first link
				$pagination .= '<li><a href="'.$urlPrev.$search.'" title="'.$titlePrev.'">&lt; '.$textPrev.'</a></li>'; //previous link
				
				for($i = ($current_page-3); $i < $current_page; $i++){ //Create left-hand side links
					if($i > 0){
						$urlPage = $this->getUrlPage($i);
						
						$pagination .= '<li><a href="'.$urlPage.$search.'">'.$i.'</a></li>';
					}
				}
				$first_link = false; //set first link to false
			}
		
			if($first_link){ //if current active page is first link
				$pagination .= '<li class="unite-first unite-active"><a href="javascript:void(0)">'.$current_page.'</a></li>';
			}elseif($current_page == $total_pages){ //if it's the last active link
				$pagination .= '<li class="unite-last unite-active"><a href="javascript:void(0)">'.$current_page.'</a></li>';
			}else{ //regular current link
				$pagination .= '<li class="unite-active"><a href="javascript:void(0)">'.$current_page.'</a></li>';
			}
			
			for($i = $current_page+1; $i < $right_links ; $i++){ //create right-hand side links
				if($i<=$total_pages){
					
					$urlPage = UniteFunctionsUC::addUrlParams($page_url, "table_page={$i}");
					
					$pagination .= '<li><a href="'.$urlPage.$search.'">'.$i.'</a></li>';
				}
			}
			
			//show first / last
			if($current_page < $total_pages && $isShowExtras == true){
				
				//next and last pages
				$next_link = ($i > $total_pages)? $total_pages : $i;
				
				$urlNext = $this->getUrlPage($next_link.$search);
				$urlLast = $this->getUrlPage($total_pages.$search);
				
				$titleNext = __("Next Page", ADDONLIBRARY_TEXTDOMAIN);
				$titleLast = __("Last Page", ADDONLIBRARY_TEXTDOMAIN);
				
				$textNext = "";
				$textLast = "";
				
				$pagination .= "<li><a href=\"{$urlNext}\" title=\"$titleNext\" >{$textNext} &gt;</a></li>"; 
				$pagination .= "<li class=\"unite-last\"><a href=\"{$urlLast}\" title=\"$titleLast\" >{$textLast} &raquo; </a></li>"; 
			}
			
			$pagination .= '</ul>';
		}
		
		return($pagination);
	}
	
	
	/**
	 * draw table pagination
	 */
	public function putPaginationHtml(){
		
		$this->validatePaging();
		
		$html = $this->getNumberInput();
		
		$html .= $this->getPaginationHtml();
		
		echo $html;
	}
	
	
}