if(typeof Tips == "undefined")
	function Tips(){};

var SqueezeBox = new function(){
	
	this.onClose = null;
	
	this.initialize = function(){};
	this.assign = function(){};
	
	
	/**
	 * open fancybox, set onclose function
	 */
	this.open = function(isMultiple, onCloseFunction, path, filetype){
		
		if(!filetype)
			var filetype = "image";
		
		this.onClose = onCloseFunction;
		
		var objFancybox = jQuery("#uc_fancybox_trigger");
		if(objFancybox.length == 0)
			throw new Error("fancybox trigger not found");
		
		//set url
		var urlJoomla = objFancybox.data("urljoomla");
		var urlElfinder = objFancybox.data("urlmediaselect");
		
		var openElfinder = false;
		if(isMultiple == true)
			openElfinder = true;
		
		//pass path
		if(path){
			openElfinder = true;
			urlElfinder += "&path=" + path;
		}
		
		//pass filetype
		switch(filetype){
			case "article":
				urlJoomla = objFancybox.data("urlarticle");			
			break;
			case "image":
			break;
			case "mp3":
				openElfinder = true;
				urlElfinder += "&filetype=mp3";
			break;
			default:
				throw new Error("Wrong filetype: "+filetype);
			break;
		}
		
		
		if(openElfinder == false)
			objFancybox.attr("href", urlJoomla);
		else
			objFancybox.attr("href", urlElfinder);
		
		objFancybox.trigger("click");
	};
	
	
	
	/**
	 * close fancybox
	 */
	this.close = function(){
		jQuery(".fancybox-close").trigger("click");
	};
	
};


/**
 * 
 * on inset image, taken from iframe
 */
function jInsertFieldValue(urlImage){
	
	if(typeof SqueezeBox.onClose == "function")
		SqueezeBox.onClose(urlImage);
	
	SqueezeBox.close();
}


/**
 * on choose article
 */
function uniteCreatorOnChooseArticle(articleID, articleTitle){
	
	if(typeof SqueezeBox.onClose == "function")
		SqueezeBox.onClose({"id":articleID,"title":articleTitle});
	
	SqueezeBox.close();
}


//global variables
var g_dataProviderUC = {
		pathSelectImages: null,
		pathSelectImagesBase:null,
		urlSelectImagesBase:null,
		objBrowserImages: null
};


/**
 * provider admin class
 */
function UniteProviderAdminUC(){
	
	var g_parent;
	
	var g_temp = {
			keyUrlAssets: "[url_assets]/"
	};
	
	/**
	 * open url dialog - add image or mp3 dialog
	 */
	function openUrlDialog(title, onInsert, isMultiple, source, filetype){
		
		var pathSelect = null;
		if(source === "addon")
			pathSelect = g_dataProviderUC.pathSelectImages;
				
		SqueezeBox.open(isMultiple, function(urlImage){
			
			if(source == "addon"){
				var urlFull = urlImage[0].url;
				var urlRelative = urlFull.replace(g_dataProviderUC.urlSelectImagesBase, "");
				var urlAssetsRelative = g_temp.keyUrlAssets+urlRelative;
				
				var obj = {};
				obj.full_url = urlFull;
				obj.url_assets_relative = urlAssetsRelative;
				onInsert(obj);
			}else{
				if(isMultiple == false && jQuery.isArray(urlImage)){
					urlImage = urlImage[0].url;
					urlImage = g_parent.urlToRelative(urlImage);
				}
				
				onInsert(urlImage);
			}
		
		},pathSelect,filetype);
		
	}
	
	
	/**
	 * open "add image" dialog
	 */
	this.openAddImageDialog = function(title, onInsert, isMultiple, source){
		
		openUrlDialog(title, onInsert, isMultiple, source, "image");
		
	};
	
	
	/**
	 * open "add mp3" dialog
	 */
	this.openAddMp3Dialog = function(title, onInsert, isMultiple, source){

		openUrlDialog(title, onInsert, isMultiple, source, "mp3");
		
	}
	
	/**
	 * open article dialog
	 */
	this.openSelectArticleDialog = function(title, onInsert, isMultiple, source){
		
		openUrlDialog(title, onInsert, false, null, "article");
		
	}
	
	
	/**
	 * get shortcode
	 */
	this.getShortcode = function(alias, catid){
		
		var addhtml = "";
		if(catid)
			addhtml = " catid="+catid;
		
		var shortcode = "{unitecreator "+alias + addhtml + "}";
		
		if(alias == "")
			shortcode = "";
		
		return(shortcode);
	};
	
	
	/**
	 * run on update settings events
	 */
	this.onSettingsUpdateEvents = function(objParent){
		
		//remove chosen elements
		setTimeout(function(){
			
			var objSelects = objParent.find(".chzn-done");
			objSelects.each(function(index, select){
				var objSelect = jQuery(select);
				var selectID = objSelect.prop("id");
				var idChosen = selectID + "_chzn";
				jQuery("#"+idChosen).remove();
				objSelect.show().removeClass(".chzn-done");
			});
			
		}, 500);

	}

	
	/**
	 * convert url assets related to full url
	 */
	this.urlAssetsToFull = function(url){
				
		if(!url)
			return("");
		
		if(!g_dataProviderUC.urlSelectImagesBase)
			return(url);
		
		var key = g_temp.keyUrlAssets;
		
		if(url.indexOf(key) == -1)
			return(url);
		
		url = url.replace(key, g_dataProviderUC.urlSelectImagesBase);
				
		return(url);
		
	}
	
	
	/**
	 * set select images path
	 */
	this.setPathSelectImages = function(path, basePath, baseUrl){
		
		if(basePath != null)
			g_dataProviderUC.pathSelectImagesBase = basePath;
			g_dataProviderUC.urlSelectImagesBase = baseUrl;
		
		g_dataProviderUC.pathSelectImages = path;
		
	}
	
	
	/**
	 * init the provider admin object
	 */
	this.init = function(){
		
		//init fancybox trigger
		jQuery("#uc_fancybox_trigger").fancybox({
			'width'				: 1000,
			'height'			: 600,
			'autoScale'			: false,
			'transitionIn'		: 'none',
			'transitionOut'		: 'none',
			'type'				: 'iframe'
		});
		
	}
	
	
	/**
	 * set parent
	 */
	this.setParent = function(parent){
		g_parent = parent;
	}
	
	
	/**
	 * get first editor options
	 */
	function initEditor_tinyMCE_GetOptions(){
				
		var objEditorsOptions = tinyMCE.editors;
		
		if(objEditorsOptions.length == 0)
			throw new Error("no active editors found for options gethering");
		
		for(key in objEditorsOptions){
			var editor = objEditorsOptions[key];
			if(editor && editor.settings)
				return(editor.settings);
		}
		
		throw new Error("editors options not found");
	}
	
	
	/**
	 * init tinymce editor
	 * take options from existing editor on page
	 */
	function initEditor_tinyMCE(inputID){
		
		var options = initEditor_tinyMCE_GetOptions();
		
		jQuery.extend(options, {
			directionality: "ltr",
            resize: "vertical",
            height: 200,
            id: inputID,
            selector: "#"+inputID
		});
		
		tinyMCE.init(options);
	}
	
	
	/**
	 * get array of inited editors
	 */
	function initEditors_afterTimeout(objSettings, arrEditorNames){
		
		var idPrefix = objSettings.getIDPrefix();
		idPrefix = idPrefix.replace("#","");
		
		jQuery(arrEditorNames).each(function(index, name){
			var inputID = idPrefix + name;
			
			if(tinyMCE.editors.hasOwnProperty(inputID) == false || tinyMCE.editors[inputID] === null)
				initEditor_tinyMCE(inputID);
			
		});
		
	}
	
	
	/**
	 * run timymce protection
	 */
	function runTinyMCEProtections(){
		
		var isProtected = jQuery(document).data("unite_tinymce_protected");
		if(isProtected === true)
			return(false);
		
		jQuery(document).data("unite_tinymce_protected", true);
		
		
		// Prevent jQuery UI dialog from blocking focusin
		jQuery(document).on('focusin', function(e) {
		   if (jQuery(e.target).closest(".mce-window, .moxman-window").length) {
			 e.stopImmediatePropagation();
		   }
		});
		
	}
	
	
	/**
	 * destroy editors
	 */
	this.destroyEditors = function(objSettings){
		
		var arrEditorNames = objSettings.getFieldNamesByType("editor_tinymce")
		if(arrEditorNames.length == 0)
			return(false);
		
		var idPrefix = objSettings.getIDPrefix();
		idPrefix = idPrefix.replace("#","");
		
		jQuery.each(arrEditorNames, function(index, name){
			var editorID = idPrefix+name;
			editorID = editorID.replace("#","");
			
			var objEditor = tinyMCE.EditorManager.get(editorID);
			
			if(objEditor){
				try{
					
					if(tinymce.majorVersion === "4")
						window.tinyMCE.execCommand("mceRemoveEditor", !0, editorID);
					else		
						window.tinyMCE.execCommand("mceRemoveControl", !0, editorID);
					
				}catch(e){					
				}
			}
			
		});
		
	}
	
	
	/**
	 * init editors
	 */
	this.initEditors = function(objSettings){
		
		var arrEditorNames = objSettings.getFieldNamesByType("editor_tinymce")
		if(arrEditorNames.length == 0)
			return(false);
		
		if(typeof tinyMCE == "undefined")
			throw new Error("Init editors error: no editor js loaded");
		
		//runTinyMCEProtections();
		
		if(tinyMCE.editors.length){
			initEditors_afterTimeout(objSettings, arrEditorNames);			
		}else{
			
			//wait until init
			
			var counter = 0;
			var handle = setInterval(function(){
				
				if(tinyMCE.editors.length){
					clearInterval(handle);
					initEditors_afterTimeout(objSettings, arrEditorNames);			
				}
				
				counter++;
				if(counter >= 100){
					clearInterval(handle);
					throw new Error("Init editor error - no other inited editors found");
				}
				
			},50);
			
		}
		
	}
	
	
}