<?php

defined('_JEXEC') or die('Restricted access');

class HelperProviderUC{

	private static $isTitleSet = false;
	private static $arrFilters = array();
	private static $mergedFilters = array();
	
	
	
	/**
	 * sanitize key
	 */
	public static function sanitizeKey($key){
		$raw_key = $key;
		$key = strtolower( $key );
		$key = preg_replace( '/[^a-z0-9_\-]/', '', $key );
		return($key);
	}
	
	
	/**
	 * set toolbar title
	 */
	public static function setToolbarTitle($titleName = null){
		
		if(self::$isTitleSet == true)
			return(false);
		
		self::$isTitleSet = true;
		
		
		$pluginName = JText::_('com_addonlibrary');
		
		if(empty($titleName))
			$showTitle = $pluginName;
		else
			$showTitle = $pluginName." - ".$titleName;
		
		JToolBarHelper::title($showTitle, 'generic.png');
		
	}
	
	
	/**
	 * Check value to find if it was serialized.
	 *
	 */
	public static function is_serialized( $data, $strict = true ) {
		// if it isn't a string, it isn't serialized.
		if ( ! is_string( $data ) ) {
			return false;
		}
		$data = trim( $data );
		if ( 'N;' == $data ) {
			return true;
		}
		if ( strlen( $data ) < 4 ) {
			return false;
		}
		if ( ':' !== $data[1] ) {
			return false;
		}
		if ( $strict ) {
			$lastc = substr( $data, -1 );
			if ( ';' !== $lastc && '}' !== $lastc ) {
				return false;
			}
		} else {
			$semicolon = strpos( $data, ';' );
			$brace     = strpos( $data, '}' );
			// Either ; or } must exist.
			if ( false === $semicolon && false === $brace )
				return false;
			// But neither must be in the first X characters.
			if ( false !== $semicolon && $semicolon < 3 )
				return false;
			if ( false !== $brace && $brace < 4 )
				return false;
		}
		$token = $data[0];
		switch ( $token ) {
			case 's' :
				if ( $strict ) {
					if ( '"' !== substr( $data, -2, 1 ) ) {
						return false;
					}
				} elseif ( false === strpos( $data, '"' ) ) {
					return false;
				}
				// or else fall through
			case 'a' :
			case 'O' :
				return (bool) preg_match( "/^{$token}:[0-9]+:/s", $data );
			case 'b' :
			case 'i' :
			case 'd' :
				$end = $strict ? '$' : '';
				return (bool) preg_match( "/^{$token}:[0-9.E-]+;$end/", $data );
		}
		return false;
	}
	
	
	/**
	 * Unserialize value only if it was serialized.
	 *
	 */
	public static function maybe_unserialize( $original ) {
		if ( self::is_serialized( $original ) ) // don't attempt to unserialize data that wasn't serialized going in
			return @unserialize( $original );
		return $original;
	}
	
	
	private function ____________FITLERS____________(){}
	
	
	/**
	 * Hook a function or method to a specific filter action.
	 *
	 */
	public static function add_filter( $tag, $function_to_add, $priority = 10, $accepted_args = 1 ) {
		
		$idx = self::filter_build_unique_id($tag, $function_to_add, $priority);
		
		self::$arrFilters[$tag][$priority][$idx] = array('function' => $function_to_add, 'accepted_args' => $accepted_args);
		
		
		return true;
	}
	
	
	/**
	 * apply filters
	 */
	public static function apply_filters( $tag, $value ) {
		
		$args = array();
	
		if(isset(self::$arrFilters[$tag]) == false)
			return($value);
	
		// Sort.
		if ( !isset( self::$mergedFilters[ $tag ] ) && isset(self::$arrFilters[$tag]) ) {
			ksort(self::$arrFilters[$tag]);
			self::$mergedFilters[ $tag ] = true;
		}
	
	
		reset( self::$arrFilters[$tag] );
	
		if ( empty($args) )
			$args = func_get_args();
	
		do {
			foreach( (array) current(self::$arrFilters[$tag]) as $the_ )
				if ( !is_null($the_['function']) ){
				$args[1] = $value;
	
				$value = call_user_func_array($the_['function'], array_slice($args, 1, (int) $the_['accepted_args']));
			}
	
		} while ( next(self::$arrFilters[$tag]) !== false );
	
	
		return $value;
	}
	
	
	/**
	 * do action
	 */
	public static function do_action($tag) {
	
		$args = array();
	
		if(isset(self::$arrFilters[$tag]) == false)
			return(false);
	
		// Sort.
		if ( !isset( self::$mergedFilters[ $tag ] ) && isset(self::$arrFilters[$tag]) ) {
			ksort(self::$arrFilters[$tag]);
			self::$mergedFilters[ $tag ] = true;
		}
	
		reset( self::$arrFilters[$tag] );
	
		if ( empty($args) )
			$args = func_get_args();
	
		do {
			foreach( (array) current(self::$arrFilters[$tag]) as $the_ )
				if ( !is_null($the_['function']) ){
				call_user_func_array($the_['function'], array_slice($args, 1, (int) $the_['accepted_args']));
			}
	
		} while ( next(self::$arrFilters[$tag]) !== false );
	
	
	}
	
	
	/**
	 * build unique ID
	 */
	private static function filter_build_unique_id($tag, $function, $priority) {
		global $wp_filter;
		static $filter_id_count = 0;
		
		if ( is_string($function) )
			return $function;
		
		if ( is_object($function) ) {
			// Closures are currently implemented as objects
			$function = array( $function, '' );
		} else {
			$function = (array) $function;
		}
				
		if (is_object($function[0]) ) {
			// Object Class Calling
			if ( function_exists('spl_object_hash') ) {
				return spl_object_hash($function[0]) . $function[1];
			} else {
				$obj_idx = get_class($function[0]).$function[1];
				if ( !isset($function[0]->wp_filter_id) ) {
					if ( false === $priority )
						return false;
					$obj_idx .= isset($wp_filter[$tag][$priority]) ? count((array)$wp_filter[$tag][$priority]) : $filter_id_count;
					$function[0]->wp_filter_id = $filter_id_count;
					++$filter_id_count;
				} else {
					$obj_idx .= $function[0]->wp_filter_id;
				}
	
				return $obj_idx;
			}
		} elseif ( is_string( $function[0] ) ) {
			// Static Calling
			return $function[0] . '::' . $function[1];
		}
		
		
	}
	
	private function a____________GLOBAL_INIT____________(){}
	
	
	/**
	 * set general settings
	 */
	public static function setGeneralSettings(UniteCreatorSettings $objSettings){
		
		
		//add general settings
		$filepathGeneral = GlobalsUC::$pathProvider."settings/general_settings.xml";
		UniteFunctionsUC::validateFilepath($filepathGeneral, "Provider general settings");
		$objSettings->addFromXmlFile($filepathGeneral);
	
	
		return($objSettings);
	}
	
	
	/**
	 * runs right after the load of all files
	 */
	public static function globalInit(){
		
		self::add_filter(UniteCreatorFilters::FILTER_MODIFY_GENERAL_SETTINGS, array("HelperProviderUC", "setGeneralSettings"));
		
	}
	
}