<?php
/**
 * @package Addon Library
 * @author UniteCMS.net / Valiano
 * @copyright (C) 2012 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */

defined('_JEXEC') or die('Restricted access');

class UniteJoomlaArticleUC extends UniteElementsBaseUC{
	
	const TABLE_CONTENT = "#__content";
	
	private $id;
	private $record;
	
	
	/**
	 * validate that the article is inited
	 */
	private function validateInited(){
		if(empty($this->id))
			UniteFunctionsUC::throwError("The article is not inited");
	}
	
	
	/**
	 * get article title
	 */
	public function getTitle($specialChars = false){
		$this->validateInited();
		
		$title = UniteFunctionsUC::getVal($this->record, "title");
		if($specialChars == true)
			$title = htmlspecialchars($title);
			
		return($title);
	}
	
	
	/**
	 * init article by db record
	 */
	public function initByRecord($record){
		
		$this->record = $record;
		$this->id = $record["id"];
	}
	
	
	/**
	 * init by id
	 */
	public function initByID($id){
		
		$id = (int)$id;
		$record = $this->db->fetchSingle(self::TABLE_CONTENT,"id=".$id);
		
		$this->initByRecord($record);
	}
	
}

