<?php

defined('_JEXEC') or die('Restricted access');

define("ADDONLIBRARY_TEXTDOMAIN","unitecreator");

class UniteProviderFunctionsUC{
	
	public static $tablePrefix;
	public static $objOptions;
	
	
	/**
	 * init base variables of the globals
	 */
	public static function initGlobalsBase(){
		
		$tablePrefix = "#__";
		
		self::$tablePrefix = $tablePrefix;
		
		GlobalsUC::$table_addons = $tablePrefix.GlobalsUC::TABLE_ADDONS_NAME;
		GlobalsUC::$table_categories = $tablePrefix.GlobalsUC::TABLE_CATEGORIES_NAME;
		GlobalsUC::$table_layouts = $tablePrefix.GlobalsUC::TABLE_LAYOUTS_NAME;
		
		$pluginName = "com_addonlibrary";
		
		GlobalsUC::$url_base = JURI::root();
		
		$pathMedia = JPATH_ROOT."/media/".$pluginName."/";
		
		$urlMedia = GlobalsUC::$url_base."media/{$pluginName}/";
		
		GlobalsUC::$pathPlugin = realpath(JPATH_ADMINISTRATOR."/components/".$pluginName)."/";
				
		GlobalsUC::$path_base = JPATH_ROOT."/";
		
		$paramsMedia = JComponentHelper::getParams('com_media');
		$dirUploads =  $paramsMedia->get("file_path");
		if(empty($dirUploads))
			$dirUploads = $paramsMedia->get("image_path");
		if(empty($dirUploads))
			$dirUploads = "images";
		
		
		GlobalsUC::$path_images = GlobalsUC::$path_base.$dirUploads."/";
		GlobalsUC::$path_cache = $pathMedia."cache/";
		
		GlobalsUC::$urlPlugin = GlobalsUC::$url_base."administrator/components/{$pluginName}/";
				
		GlobalsUC::$url_component_client = GlobalsUC::$url_base."index.php?option=".$pluginName;
		GlobalsUC::$url_component_admin = JURI::current()."?option=".$pluginName;
	
		GlobalsUC::$url_images = GlobalsUC::$url_base."images/";
		
		GlobalsUC::$url_ajax = GlobalsUC::$url_component_admin;
		GlobalsUC::$url_ajax_front = GlobalsUC::$url_component_client;
		
		GlobalsUC::$is_admin = self::isAdmin();
		
		GlobalsUC::$pathAssets = $pathMedia."assets/";
		GlobalsUC::$url_assets = $urlMedia."assets/";
		GlobalsUC::$url_assets_internal = $urlMedia."assets_internal/";
		
		GlobalsUC::$url_provider = GlobalsUC::$urlPlugin."provider/";
		GlobalsUC::$url_default_addon_icon = GlobalsUC::$url_provider."assets/images/icon_default_addon.png";
		
		GlobalsUC::$url_assets_libraries = $urlMedia."assets_libraries/";
		
		GlobalsUC::$view_default = GlobalsUC::VIEW_LAYOUTS_LIST;
		
		
		$joomlaTemplate = UniteFunctionsUC::getGetVar("tmpl","", UniteFunctionsUC::SANITIZE_KEY);
		if($joomlaTemplate == "component")
			GlobalsUC::$blankWindowMode = true;
				
	}
	
	
	/**
	 * get object function
	 */
	public static function getObjOptions(){
		
		if(empty(self::$objOptions))
			self::$objOptions = new ProviderOptionsUC();
		
		return(self::$objOptions);
	}
	
	
	/**
	 * add scripts and styles framework
	 */
	public static function addScriptsFramework(){

		self::addAdminJQueryInclude();
		
		$urljQueryUI = GlobalsUC::$url_provider."assets/jquery-ui.min.js";
		HelperUC::addScriptAbsoluteUrl($urljQueryUI, "jquery-ui");
		
		HelperUC::addStyle("jquery-ui.min","jui-minified","css/jui/new");
		
		$urlFancyboxJs = GlobalsUC::$url_provider."assets/fancybox/jquery.fancybox.pack.js";
		HelperUC::addScriptAbsoluteUrl($urlFancyboxJs, "fancybox");
		
		$urlFancyboxCss = GlobalsUC::$url_provider."assets/fancybox/jquery.fancybox.css";
		HelperUC::addStyleAbsoluteUrl($urlFancyboxCss, "fancybox-css");
		
	}
	
	
	/**
	 * add admin jquery include
	 */
	public static function addAdminJQueryInclude(){
		
		$isJoomla3 = UniteFunctionJoomlaUC::isJoomla3();
		
		if($isJoomla3 == false){
			$urljQuery = GlobalsUC::$url_provider."assets/jquery-1.11.1.min.js";
			HelperUC::addScriptAbsoluteUrl($urljQuery, "jquery");
			HelperUC::addScriptCommon("jquery-1.11.1.min","jquery");
		}
		else{
			JHtml::_('jquery.framework');
		}
		
	}
	
	
	/**
	 *
	 * register script
	 */
	public static function addScript($handle, $url){
	
		if(empty($url))
			UniteFunctionsUC::throwError("empty script url, handle: $handle");
		
		$url = UniteFunctionsUC::addUrlParams($url, "ucver=".ADDON_LIBRARY_VERSION);
		
		$document = JFactory::getDocument();
		$document->addScript($url);
	
	}
	
	
	/**
	 *
	 * register script
	 */
	public static function addStyle($handle, $url){
	
		if(empty($url))
			UniteFunctionsUG::throwError("empty style url, handle: $handle");
	
		$url = UniteFunctionsUC::addUrlParams($url, "ucver=".ADDON_LIBRARY_VERSION);
		
		$document = JFactory::getDocument();
		$document->addStyleSheet($url);
	
	}
	
	
	/**
	 *
	 * sanitize data, in joomla no need to sanitize
	 */
	public static function normalizeAjaxInputData($arrData){
	
		return $arrData;
	}
	
	
	/**
	 * put footer text line
	 */
	public static function putFooterTextLine(){
		?>
			&copy; <?php _e("All rights reserved",ADDONLIBRARY_TEXTDOMAIN)?>, <a href="http://unitecms.net" target="_blank">UniteCMS</a>. &nbsp;&nbsp;
		<?php
	}
		
	
	/**
	 * print custom script
	 */
	public static function printCustomScript($script, $hardCoded = false){
	
		if($hardCoded == false)
			UniteFunctionJoomlaUC::addScriptDeclaration($script);
		else
			echo "<script type='text/javascript'>{$script}</script>";
	
	}
	
	/**
	 * print custom script
	 */
	public static function printCustomStyle($style, $hardCoded = false){
		
		if($hardCoded == false)
			UniteFunctionJoomlaUC::addStyleDeclaration($style);
		else
			echo "<style type='text/css'>{$style}</style>";
	
	}
	
	
	/**
	 * get if area is admin or not
	 */
	public static function isAdmin(){
		$app = JFactory::getApplication();
		return($app->isAdmin());		
	}
	
	
	/**
	 * put master provider html
	 */
	public static function putMasterHTML(){
		
		$urlJoomla = "index.php?option=com_media&view=images&tmpl=component&author=&fieldid=field_image_dialog_choose";
		$urlArticle = "index.php?option=com_content&view=articles&layout=modal&tmpl=component&function=uniteCreatorOnChooseArticle";
		
		$urlElfinder = HelperUC::getViewUrl(GlobalsUC::VIEW_MEDIA_SELECT);
		$text = __("Fancybox Trigger", ADDONLIBRARY_TEXTDOMAIN);
		
		?>
			<a id="uc_fancybox_trigger" style="display:none" data-urlarticle="<?php echo $urlArticle?>" data-urljoomla="<?php echo $urlJoomla?>" data-urlmediaselect="<?php echo $urlElfinder?>" href="<?php echo $urlJoomla?>"><?php echo $text?></a>
		<?php 
	}	

	
	/**
	 * add system contsant data to template engine
	 */
	public static function addSystemConstantData($data){
		
		/*
			$postID = get_the_ID();
			
			//set post data
			$post = UniteFunctionsWPUC::getPost($postID, true, true);
			$data["post"] = $this->modifyPostData($post);
		*/
		
		return($data);
	}

	/**
	 * wrap shortcode with some wrappers
	 */
	public static function wrapShortcode($shortcode){
		$shortcode = "{".$shortcode."}";
		
		return($shortcode);
	}
	
	
	/**
	 * get image url from image id
	 */
	public static function getImageUrlFromImageID($imageID){
		
		return(null);
	}
	
	
	/**
	 * get image id from url
	 */
	public static function getImageIDFromUrl($urlImage){
		
		return(null);
	}
	
	
	/**
	 * get image url from image id
	 */
	public static function getThumbUrlFromImageID($imageID, $size = null){	
		
		return(null);
	}
	
	
	/**
	 * put addons view additional html
	 */
	public static function putAddonViewAddHtml(){
		
		$urlLayouts = HelperUC::getViewUrl_LayoutsList();
		
		?>
	
		<a href="<?php echo $urlLayouts?>" class="unite-float-left mright_20 unite-button-secondary"><?php _e("My Layouts", ADDONLIBRARY_TEXTDOMAIN)?></a>
		
		<div class="unite-clear"></div>
		
		<div class="vert_sap20"></div>
	
	<?php
	}
	
	
	/**
	* get plugin paths array
	*/
	public static function getArrPluginsPaths(){
	
		$objPluginsBase = new AddonLibraryJoomlaPluginsBase();
		$arrPluginsPaths = $objPluginsBase->getPluginsPaths();
	
		return($arrPluginsPaths);
	}
	
	
	/**
	 * filter variable
	 */
	public static function sanitizeVar($var, $type){
	
		switch($type){
			case UniteFunctionsUC::SANITIZE_ID:
				if(empty($var))
					return("");
	
				$var = (int)$var;
				$var = abs($var);
	
				if($var == 0)
					return("");
	
			break;
			case UniteFunctionsUC::SANITIZE_KEY:
				$var = HelperProviderUC::sanitizeKey($var);
			break;
			case UniteFunctionsUC::SANITIZE_TEXT_FIELD:
			break;
			case UniteFunctionsUC::SANITIZE_NOTHING:
				break;
			default:
				self::throwError("Wrong sanitize type: " . $type);
			break;
		}
	
		return($var);
	}
	
	
	/**
	 * put helper editor to help init other editors that has put by ajax
	 */
	public static function putInitHelperHtmlEditor(){
		
		$params = array();
		$params["mode"] = 1;
		
		?>
		<div style="display:none">
		
		<?php
		
		$editor = JEditor::getInstance("tinymce");
		
		//dmp($editor);exit();
		
		echo $editor->display("uc_editor_helper","","100%",200,5,5,true,null,null,null,$params);
		
		?>
	
		</div>
	<?php
	
	}
	
	
	public static function ______________OPTIONS______________(){}
	
	
	/**
	 * get options object
	 */
	public static function getOptionsObj(){
		if(empty(self::$objOptions))
			self::$objOptions = new ProviderOptionsUC();
		
		return(self::$objOptions);
	}
	
	
	/**
	 * add option
	 */
	public static function addOption($option, $value=""){
	
		$objOptions = self::getOptionsObj();
		$objOptions->addOption($option, $value="");
	
	}
	
	
	/**
	 * get option
	 */
	public static function getOption($option, $default = false){
		$objOptions = self::getOptionsObj();
	
		return $objOptions->getOption($option, $default);
	
	}
	
	/**
	 * update option
	 */
	public static function updateOption($option, $value){
		$objOptions = self::getOptionsObj();
	
		$response = $objOptions->updateOption($option, $value);
	
		return($response);
	}
	
	/**
	 * emulate special wp option
	 */
	public static function updateOptionSpecial($option, $value, $isMultisite=false, $loadAtStartup=false){
	
		return self::updateOption($option, $value);
	}
	
	
	/**
	 * delete one option
	 * @param $option
	 */
	public static function deleteOption($option){
		$objOptions = self::getOptionsObj();
	
		$response = $objOptions->deleteOption($option);
	
		return($response);
	}
	
	
	/**
	 * set transient
	 */
	public static function setTransient($transient, $value, $expiration = 0){
		$objOptions = self::getOptionsObj();
	
		$response = $objOptions->setTransient($transient, $value, $expiration);
	
		return($response);
	}
	
	
	/**
	 * get transient
	 * if empty - get false
	 */
	public static function getTransient($transient){
		$objOptions = self::getOptionsObj();
	
		$response = $objOptions->getTransient($transient);
	
		return($response);
	}
	
		
	public static function ______________ACTIONS_AND_FILTERS______________(){}
	
	
	/**
	 * add action
	 */
	public static function addAction($tag, $function_to_add){
		HelperProviderUC::add_filter($tag, $function_to_add);
	}

	/**
	 * add filter
	 */
	public static function addFilter($tag, $function_to_add, $priority = 10, $accepted_args = 1){
		HelperProviderUC::add_filter($tag, $function_to_add, $priority, $accepted_args);
	}
	
	
	/**
	 * apply filters
	 */
	public static function applyFilters($tag, $value){
		
		return call_user_func_array(array("HelperProviderUC","apply_filters"), func_get_args());
	}
	
	
	/**
	 * do action emulation. do nothing for now
	 */
	public static function doAction($tag){
	
		call_user_func_array(array("HelperProviderUC","do_action"), func_get_args());
	}
	
	/**
	 * convert url to new window
	 */
	public static function convertUrlToBlankWindow($url){
		$params = "tmpl=component";
		
		$url = UniteFunctionsUC::addUrlParams($url, $params);
		
		return($url);
	}
	
}
?>