<?php

/**
 * @package Addon Library
 * @author UniteCMS.net
 * @copyright (C) 2012 Unite CMS, All Rights Reserved.
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */

class UniteSettingsOutputUC extends UniteSettingsOutputUCWork{

	
	/**
	 * draw post picker input
	 * value is post id
	 */
	protected function drawPostPickerInput($setting){
			
			$value = UniteFunctionsUC::getVal($setting, "value");
			
			$postTitle = "";
			
			if(empty($value))
				$value = "";
			else{		//get post title
				
				try{
					$article = new UniteJoomlaArticleUC();
					$article->initByID($value);
					$postTitle = $article->getTitle(true);
				
				}catch(Exception $e){
					$value = "";
				}
			}
			
			$class = $this->getInputClassAttr($setting, "", "unite-postpicker-input");
			$addHtml = $this->getDefaultAddHtml($setting);
			$addHtml .= " data-initval-title=\"{$postTitle}\"";
			
			$dialogTitle = __("Select Article", ADDONLIBRARY_TEXTDOMAIN);
			
			?>
			<div class="unite-settings-postpicker">
				<input type="text" disabled id="<?php echo $setting["id"]?>" data-postid="<?php echo $value?>" name="<?php echo $setting["name"]?>" <?php echo $class?> value="<?php echo $postTitle?>" <?php echo $addHtml?> />
				<a class="unite-button-secondary uc-button-select-post" data-dialogtitle="<?php echo $dialogTitle?>"><?php _e("Select Article", ADDONLIBRARY_TEXTDOMAIN)?></a>
			</div>
			
		<?php
	}
	
	
	/**
	 * draw editor input
	 */
	protected function drawEditorInput($setting){

		$disabled = "";
		if (isset($setting["disabled"]))
			$disabled = 'disabled="disabled"';
		
		$style = "";
		if(isset($setting["style"]))
			$style = "style='".$setting["style"]."'";
		
		$addHtml = $this->getDefaultAddHtml($setting);
		
		$editor = JEditor::getInstance("tinymce");
		
		$name = $setting["name"];
		$value = UniteFunctionsUC::getVal($setting, "value");
		$value = htmlspecialchars($value, ENT_COMPAT, 'UTF-8');
		$width = "100%";
		$height = "200";
		$cols = 5;
		$rows = 3;
		$buttons = false;
		$id = $setting["id"];
		
		$addHtml = $this->getDefaultAddHtml($setting);
		
		$params = array();
		$params["html_height"] = $height;
		$params["mode"] = 1;
		
		$html = "<div class='unite-editor-setting-wrapper unite-editor-joomla' {$addHtml} >";
		
		$html .= $editor->display(
				$name, $value , $width, $height, $cols, $rows,
				$buttons, $id, null,
				null, $params);
		
		$html .= "</div>";
		
		echo $html;
	}
	
	
	
	
}