<?php

defined('_JEXEC') or die;

class UniteCreatorAddonViewProvider extends UniteCreatorAddonView{
	
	private $addonID_provider;
	private $addonType_provider;
	
	
	/**
	 * add update button
	 */
	private function addToolbar_update(){
		
		$textUpdate = __("Update", ADDONLIBRARY_TEXTDOMAIN);
		$textUpdating = __("Updating...", ADDONLIBRARY_TEXTDOMAIN);
		
		$html = "";
		$html .= '<span class="uc-toolbar-save-wrapper">';
		$html .= '<a id="button_update_addon" class="button_update_addon unite-button-primary" href="javascript:void(0)">'.$textUpdate.'</a>';
		$html .= '<div style="padding-top:6px;">';
		$html .= '<span id="uc_loader_update" class="loader_text" style="display:none">'.$textUpdating.'</span>';
		$html .= '<span id="uc_message_addon_updated" class="unite-color-green" style="display:none"></span>';
		$html .= '</div>';
		$html .= '</span>';
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "update_addon");
		
	}
	
	
	/**
	 * add back button
	 */
	private function addToolbar_back(){
		
		$urlBack = HelperUC::getViewUrl_Addons($this->addonType_provider);
		$textBack = __("Back to Addons List", ADDONLIBRARY_TEXTDOMAIN);
		
		$html = "";
		$html .= '<a class="unite-button-secondary" href="'.$urlBack.'">'.$textBack.'</a>';
		$html .= '<span class="uc-toolbar-sap"></span>';

		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "back_button");
		
		return($html);
	}
	
	
	/**
	 * test addon
	 */
	private function addToolbar_testAddon(){
		
		$urlTestAddon = HelperUC::getViewUrl_TestAddon($this->addonID_provider);
		
		$textTestAddon = __("Test Addon", ADDONLIBRARY_TEXTDOMAIN);
		
		$html = "";
		$html .= '<a href="'.$urlTestAddon.'" class="unite-button-secondary " >'.$textTestAddon.'</a>';
		$html .= '<span class="uc-toolbar-sap"></span>';
		
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "test_addon");
		
		return($html);
	}
	
	
	/**
	 * preview addon
	 */
	private function addToolbar_previewAddon(){
		
		$urlPreviewAddon = HelperUC::getViewUrl_TestAddon($this->addonID_provider, "preview=1");
		
		$textPreview = __("Preview Addon", ADDONLIBRARY_TEXTDOMAIN);
		
		$html = "";
		$html .= '<a href="'.$urlPreviewAddon.'" class="unite-button-secondary " >'.$textPreview.'</a>';
		$html .= '<span class="uc-toolbar-sap"></span>';

		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "test_addon");
		
		return($html);
	}
	
	
	/**
	 * add joomla toolbar
	 */
	private function addToolbar(){
		
		$this->addonID_provider = $this->objAddon->getID();
		$this->addonType_provider = $this->objAddon->getType();
		
		$this->addToolbar_update();
		$this->addToolbar_back();
		$this->addToolbar_testAddon();
		$this->addToolbar_previewAddon();
		
	}
	
	
	/**
	 * set header text
	 */
	private function setJoomlaHeaderText(){
		
		$title = $this->getHeaderTitle();
		
		HelperProviderUC::setToolbarTitle($title);
	}
	
	
	/**
	 * constructor
	 */
	public function __construct(){
		
		$this->showHeader = false;
		$this->showToolbar = false;
		
		parent::__construct();
		
		$this->setJoomlaHeaderText();
		
		$this->addToolbar();
	}
	
}