<?php

defined('ADDON_LIBRARY_INC') or die;

class AddonLibraryViewLayoutProvider extends AddonLibraryViewLayout{
	
	
	/**
	 * add save button
	 */
	private function addToolbar_save(){
		
		$textUpdating = __("Saving...", ADDONLIBRARY_TEXTDOMAIN);
		$textUpdate = __("Save", ADDONLIBRARY_TEXTDOMAIN);
		$textSaved = __("Layout Saved", ADDONLIBRARY_TEXTDOMAIN);
		
		$html = "";
		
		$html .= "<span class=\"uc-toolbar-save-wrapper\" >";
		
		$html .= "<a id=\"uc_button_update_layout\" class=\"button_update_addon unite-button-primary\" href=\"javascript:void(0)\">{$textUpdate}</a>";
		
		$html .= "<div style=\"padding-top:6px;\">";
		$html .= "<span id=\"uc_loader_update\" class=\"loader_text\" style=\"display:none\"> {$textUpdating} </span>";
		$html .= "<span id=\"uc_message_addon_updated\" class=\"unite-color-green\" style=\"display:none\">{$textSaved}</span>";
		$html .= "</div>";
		
		$html .= "</span>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "update_layout");
		
	}
	
	
	/**
	 * add toolbar back button
	 */
	private function addToolbar_back(){
		
		$urlLayoutsList = HelperUC::getViewUrl_LayoutsList();
		$textBack = __("Back to layouts list",ADDONLIBRARY_TEXTDOMAIN);
		
		$html = "";
		$html .= "<a href=\"{$urlLayoutsList}\" class=\"unite-button-secondary\">{$textBack}</a>";
		$html .= "<span class='uc-toolbar-sap'></span>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "back_button");
		
	}
	
	
	/**
	 * add preview button
	 */
	private function addToolbar_preview(){
		
		if($this->layoutID == false)
			return(false);
		
		$urlLayoutsPreview = HelperUC::getViewUrl_LayoutPreview($this->layoutID);
				
		$textPreview = __("Preview",ADDONLIBRARY_TEXTDOMAIN);
		
		$html = "";
		$html .= "<a href=\"{$urlLayoutsPreview}\" class=\"unite-button-secondary\">{$textPreview}</a>";
		$html .= "<span class='uc-toolbar-sap'></span>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "preview_button");
		
	}
	
	/**
	 * add preview button
	 */
	private function addToolbar_preview_new(){
	
		if($this->layoutID == false)
			return(false);
	
		$urlLayoutsPreview = HelperUC::getViewUrl_LayoutPreview($this->layoutID);
		$urlLayoutsPreviewNew = $urlLayoutsPreview."&tmpl=component";
		
		$textPreview = __("Preview New Window",ADDONLIBRARY_TEXTDOMAIN);
		
		$html = "";
		$html .= "<a href=\"{$urlLayoutsPreviewNew}\" target=\"_blank\" class=\"unite-button-secondary\">{$textPreview}</a>";
		$html .= "<span class='uc-toolbar-sap'></span>";
	
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "preview_button");
	
	}
	
	
	/**
	 * add grid settings button
	 */
	private function addToolbar_gridSettings(){
		
		$textGridSettings = __("Grid Settings",ADDONLIBRARY_TEXTDOMAIN);
		
		$html = "";
		$html .= "<a id=\"uc_button_grid_settings\" href=\"javascript:void(0)\" class=\"unite-button-secondary unite-float-right\">{$textGridSettings}</a>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "grid_settings");
		
	}
	
	
	/**
	 * add export toolbar
	 */
	private function addToolbar_export(){
		
		$textExport = __("Export", ADDONLIBRARY_TEXTDOMAIN);
		
		$html = "";
		$html .= "<a id=\"uc_button_export_layout\" href=\"javascript:void(0)\" class=\"unite-button-secondary unite-float-right\">{$textExport}</a>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "export_layout");
		
	}
	
	/**
	 * add import button
	 */
	private function addToolbar_import(){
	
		$textImport = __("Import", ADDONLIBRARY_TEXTDOMAIN);
	
		$html = "";
		$html .= "<a id=\"uc_button_import_layout\" href=\"javascript:void(0)\" class=\"unite-button-secondary unite-float-right\">{$textImport}</a>";
	
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "import_layout");
	
	}
	
	/**
	 * add joomla toolbar
	 */
	private function addToolbar(){
		
		$this->addToolbar_back();

		if($this->layoutID){
			$this->addToolbar_preview();
			$this->addToolbar_preview_new();
			
		}
		
		$this->addToolbar_save();
		
		$this->addToolbar_gridSettings();

		if($this->layoutID){
			$this->addToolbar_import();
			
			$this->addToolbar_export();
			
			UniteProviderFunctionsUC::doAction(UniteCreatorFilters::ACTION_ADD_LAYOUT_TOOLBAR_BUTTON);
		}
		
	}
	
	
	/**
	 * set header text
	 */
	private function setJoomlaHeaderText(){
	
		$title = $this->getHeaderTitle();
		
		HelperProviderUC::setToolbarTitle($title);
	}
	
	
	/**
	 * add toolbar
	 */
	function __construct(){
		parent::__construct();
		
		$this->showButtons = false;
		$this->showHeader = false;
		
		$this->addToolbar();
		$this->setJoomlaHeaderText();
		
		$this->display();
	}
	
	
}