<?php

defined('ADDON_LIBRARY_INC') or die;

class UniteCreatorLayoutPreviewProvider extends UniteCreatorLayoutPreview{

	
	/**
	 * add preview button
	 */
	private function addToolbar_preview_new(){
		
		$urlLayoutsPreview = HelperUC::getViewUrl_LayoutPreview($this->layoutID);
		$urlLayoutsPreviewNew = $urlLayoutsPreview."&tmpl=component";
	
		$textPreview = __("Preview New Window",ADDONLIBRARY_TEXTDOMAIN);
	
		$html = "";
		$html .= "<a href=\"{$urlLayoutsPreviewNew}\" target=\"_blank\" class=\"unite-button-secondary\">{$textPreview}</a>";
		$html .= "<span class='uc-toolbar-sap'></span>";
	
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "preview_button");
	
	}
	
	
	/**
	 * add grid settings button
	 */
	private function addToolbar_toList(){
	
		$textBack = __("Back to layouts list",ADDONLIBRARY_TEXTDOMAIN);
		$urlLayoutsList = HelperUC::getViewUrl_LayoutsList();
		
		$html = "";
		$html .= "<a href=\"{$urlLayoutsList}\" class=\"unite-button-secondary\">{$textBack}</a>";
		$html .= '<span class="uc-toolbar-sap"></span>';
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "url_back");
	
	}

	
	/**
	 * add grid settings button
	 */
	private function addToolbar_editLayout(){
	
		$textEdit = __("Edit Layout",ADDONLIBRARY_TEXTDOMAIN);
		$urlEdit = HelperUC::getViewUrl_Layout($this->layoutID);
		
		$html = "";
		$html .= "<a href=\"{$urlEdit}\" class=\"unite-button-secondary\">{$textEdit}</a>";
		$html .= '<span class="uc-toolbar-sap"></span>';
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "url_edit");
		
	}
	
	
	/**
	 * add joomla toolbar
	 */
	private function addToolbar(){
		
		$this->addToolbar_toList();
		$this->addToolbar_editLayout();
		$this->addToolbar_preview_new();
	}
	
	/**
	 * set header text
	 */
	private function setJoomlaHeaderText(){
		
		$title = $this->getHeaderTitle();
	
		HelperProviderUC::setToolbarTitle($title);
	}
	
	
	/**
	 * constructor
	 */
	public function __construct(){
				
		$this->showToolbar = false;
		
		parent::__construct();
		
		$this->setJoomlaHeaderText();
				
		$this->addToolbar();
		
		$this->display();
	}
	
}