<?php

defined('ADDON_LIBRARY_INC') or die;

class UniteCreatorLayoutsViewProvider extends UniteCreatorLayoutsView{

		
	
	/**
	* new layout add
	 */
	private function addToolbar_newLayout(){
		
		$text = __("New Layout", ADDONLIBRARY_TEXTDOMAIN);
		$urlViewCreateObject = HelperUC::getViewUrl_Layout();
		
		$html = "";
		$html .= "<a href=\"{$urlViewCreateObject}\" class=\"unite-button-primary unite-float-left\">{$text}</a>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "new_layout");
	}
	
	
	/**
	 * new layout add
	 */
	private function addToolbar_importLayout(){
	
		$text = __("Import Layout", ADDONLIBRARY_TEXTDOMAIN);
		
		$html = "";
		$html .= "<a id=\"uc_button_import_layout\" href=\"javascript:void(0)\" class=\"unite-button-secondary unite-float-left mleft_20\">{$text}</a>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "new_layout");
	}
	
	/**
	 * new layout add
	 */
	private function addToolbar_globalSettings(){
		
		$text = __("Layouts Global Settings", ADDONLIBRARY_TEXTDOMAIN);
	
		$html = "";
		$html .= "<a href=\"javascript:void(0)\" id=\"uc_layouts_global_settings\" class=\"unite-float-right mright_20 unite-button-secondary\">{$text}</a>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "global_settings");
	}
	
	
	/**
	 * new layout add
	 */
	private function addToolbar_manageAddons(){
	
		$text = __("My Addons", ADDONLIBRARY_TEXTDOMAIN);
		$urlManageAddons = HelperUC::getViewUrl_Addons();
		
		$html = "";
		$html .= "<a href=\"{$urlManageAddons}\" class=\"unite-float-right mright_20 unite-button-secondary\">{$text}</a>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "manage_addons");
	}
	
	
	/**
	 * add joomla toolbar
	 */
	private function addToolbar(){
		
		$this->addToolbar_newLayout();
		$this->addToolbar_importLayout();
		$this->addToolbar_globalSettings();
		$this->addToolbar_manageAddons();
		
	}
	
	/**
	 * set header text
	 */
	private function setJoomlaHeaderText(){
	
		$title = __("Manage Layouts", ADDONLIBRARY_TEXTDOMAIN);
	
		HelperProviderUC::setToolbarTitle($title);
	}
	
	
	/**
	 * constructor
	 */
	public function display(){
	
		$this->showButtonsPanel = false;
		$this->showHeaderTitle = false;
		
		$this->setJoomlaHeaderText();
		$this->addToolbar();
		
		parent::display();
	}
	
	
}