<?php

defined('_JEXEC') or die;

class UniteCreatorTestAddonViewProvider extends UniteCreatorTestAddonView{
	
	
	
	/**
	 * add edit link
	 */
	private function addToolbar_edit(){
		
		$urlEditAddon = HelperUC::getViewUrl_EditAddon($this->addonID);
		$buttonText = __("Edit This Addon", ADDONLIBRARY_TEXTDOMAIN);
		
		$html = '<a href="'.$urlEditAddon.'" class="unite-button-secondary" >'.$buttonText.'</a>';
		
		UniteFunctionJoomlaUC::addToolbarCustomButton($html, "edit_addon");
	}
	
	
	/**
	* add back button
	*/
	private function addToolbar_back(){
		
		$addonType = $this->addon->getType();
		
		$text = __("Back to Addons List", ADDONLIBRARY_TEXTDOMAIN);
		
		$addonsView = HelperUC::getViewUrl_Addons($addonType);
		
		$html = '<a class="unite-button-secondary uc-button-cat-sap" href="'.$addonsView.'">'.$text.'</a>';
		
		UniteFunctionJoomlaUC::addToolbarCustomButton($html, "back_to_addons");
	}
	
	
	
	/**
	 * add preview buttons
	 */
	private function addToolbar_preview(){
		
		$isPreviewMode = $this->isPreviewMode;
		
		$styleShow = "";
		$styleHide = "style='display:none'";
		$textToPreview = __("To Preview", ADDONLIBRARY_TEXTDOMAIN);
		$textHidePreview = __("Hide Preview", ADDONLIBRARY_TEXTDOMAIN);
		$textPreviewNewTab = __("Preview New Tab", ADDONLIBRARY_TEXTDOMAIN);
		
		
		$stylePreview = $isPreviewMode?$styleHide:$styleShow;
		
		$styleHidePreview = $isPreviewMode?$styleShow:$styleHide;
		
		$html = "";
		$html .= '<a id="uc_button_preview" href="javascript:void(0)" class="unite-button-secondary"'. $stylePreview.'>'.$textToPreview.'</a>';
		$html .= '<a id="uc_button_close_preview" href="javascript:void(0)" class="unite-button-secondary" '.$styleHidePreview.'>'.$textHidePreview.'</a>';
		$html .= '<a id="uc_button_preview_tab" href="javascript:void(0)" class="unite-button-secondary uc-button-cat-sap">'.$textPreviewNewTab.'</a>';
		
		UniteFunctionJoomlaUC::addToolbarCustomButton($html, "preview_buttons");
	}
	
	
	/**
	 * add test addon slot
	 */
	private function addToolbar_slot1(){
		?>
		<span id="uc_testaddon_slot1" class="uc-testaddon-slot" <?php echo $slot1AddHtml?>>
			<a id="uc_testaddon_button_restore" href="javascript:void(0)" class="unite-button-secondary"><?php _e("Restore Data", ADDONLIBRARY_TEXTDOMAIN)?></a>
			<span id="uc_testaddon_loader_restore" class="loader-text" style="display:none"><?php _e("loading...")?></span>
			<a id="uc_testaddon_button_delete" href="javascript:void(0)" class="unite-button-secondary"><?php _e("Delete Data", ADDONLIBRARY_TEXTDOMAIN)?></a>
			<span id="uc_testaddon_loader_delete" class="loader-text" style="display:none"><?php _e("deleting...")?></span>
		</span>
		<?php 
	}
	
	
	/**
	 * add save and clear buttons
	 */
	private function addToolbar_save_clear(){
		?>
			<a id="uc_testaddon_button_save" href="javascript:void(0)" class="unite-button-secondary"><?php _e("Save Data", ADDONLIBRARY_TEXTDOMAIN)?></a>
			<span id="uc_testaddon_loader_save" class="loader-text" style="display:none"><?php _e("saving...")?></span>
			
			<a id="uc_testaddon_button_clear" href="javascript:void(0)" class="unite-button-secondary"><?php _e("Clear", ADDONLIBRARY_TEXTDOMAIN)?></a>
		<?php 
	}
	
	
	/**
	 * add joomla toolbar
	 */
	private function addToolbar(){
		
		$this->addToolbar_edit();
		$this->addToolbar_back();
		$this->addToolbar_preview();
	}
	
	
	/**
	 * constructor
	 */
	public function __construct(){
		
		//$this->showHeader = false;
		//$this->showToolbar = false;
		
		parent::__construct();
		
		//$this->setJoomlaHeaderText();
		
		//$this->addToolbar();
		
	}
	
	
}